import 'package:models_weebi/src/closings/abstract/closing_boutique.dart';
import 'package:models_weebi/src/closings/closing_stock.dart';

import 'package:models_weebi/src/closings/closing_range.dart';
import 'package:models_weebi/src/closings/closing_stock_shop/closing_stock_boutique_article.dart';
import 'package:models_weebi/src/closings/closing_stock_shop/closing_stock_boutique_art_calibre.dart';

class ClosingStockBoutique<P extends ClosingStockBoutiqueCalibre>
    extends ClosingStock<P> implements ClosingBoutiqueAbstract {
  @override
  int boutiqueId;
  ClosingStockBoutique(
    super.closingRange, {
    required this.boutiqueId,
    List<P>? articleCalibres,
  }) : super(articleCalibres: articleCalibres ?? []);

  @override
  bool operator ==(other) => identical(closingRange, other);
  @override
  int get hashCode => closingRange.hashCode;

  @override
  Map<String, dynamic> toMap() {
    return {
      'boutiqueId': boutiqueId,
      'closingRange': closingRange.toMap(),
      'articleCalibres': articleCalibres.map((x) => x.toMap()).toList(),
    };
  }

  factory ClosingStockBoutique.fromMap(Map<String, dynamic> map) {
    return ClosingStockBoutique(
      ClosingRange.fromMap(map['closingRange']),
      boutiqueId: map['boutiqueId'] as int,
      articleCalibres: map['articleCalibres'] == null
          ? []
          : List<P>.from(map['articleCalibres']
              .map((x) => ClosingStockBoutiqueCalibre.fromMap(x))),
    );
  }
  static final dummyFeb = [
    ClosingStockBoutique(
      ClosingRange.dummyFeb,
      boutiqueId: 0,
      articleCalibres: [
        ClosingStockBoutiqueCalibre(ClosingRange.dummyFeb.date,
            id: 1,
            boutiqueId: 0,
            title: 'abondance',
            initialQtCl: 0.0,
            finalQtCl: 3.0,
            articles: [
              ClosingStockBoutiqueArticle(
                ClosingRange.dummyFeb.date,
                calibreId: 1,
                id: 1,
                boutiqueId: 0,
                designation: 'fromage abondance kg',
                unitsInOnePiece: 1.0,
                quantityIn: 3.0,
                quantityOut: 0.0,
                initialQtCl: 0.0,
                finalQtCl: 3.0,
              ),
            ]),
      ],
    ),
  ];
  static final dummyMar = [
    ClosingStockBoutique(
      ClosingRange.dummyMar,
      boutiqueId: 0,
      articleCalibres: [
        ClosingStockBoutiqueCalibre(ClosingRange.dummyMar.date,
            id: 1,
            boutiqueId: 0,
            title: 'abondance',
            initialQtCl: 3.0,
            finalQtCl: 5.0,
            articles: [
              ClosingStockBoutiqueArticle(
                ClosingRange.dummyMar.date,
                calibreId: 1,
                id: 1,
                boutiqueId: 0,
                designation: 'fromage abondance kg',
                unitsInOnePiece: 1.0,
                quantityIn: 2.0,
                quantityOut: 0.0,
                initialQtCl: 3.0,
                finalQtCl: 5.0,
              ),
            ]),
      ],
    ),
  ];
}
