import 'package:models_weebi/src/closings/abstract/closing_boutique.dart';
import 'package:models_weebi/src/closings/closing_stock_article_calibre.dart';
import 'package:models_weebi/src/closings/closing_range.dart';
import 'package:models_weebi/src/closings/closing_stock_shop/closing_stock_boutique_article.dart';
import 'package:models_weebi/utils.dart';

class ClosingStockBoutiqueCalibre extends ClosingStockCalibre
    implements ClosingBoutiqueAbstract {
//  le shopUuid pour être en mesure de retrouver l'historique d'un produit, notammnent si l'on doit analyser des transferts entre magasin
  @override
  int boutiqueId;

  ClosingStockBoutiqueCalibre(
    super.closingDate, {
    required this.boutiqueId,
    required super.id,
    required super.title,
    required super.initialQtCl,
    required super.finalQtCl,
    required List<ClosingStockBoutiqueArticle> super.articles,
    super.status = true,
  });

  factory ClosingStockBoutiqueCalibre.fromMap(Map<String, dynamic> map) {
    return ClosingStockBoutiqueCalibre(
      DateTime.tryParse(map['closingDate']) ?? DatesWeebi.defaultDate,
      boutiqueId: map['boutiqueId'] as int,
      id: map['id'],
      title: map['title'],
      status: map['status'],
      initialQtCl: map['initialQtCl'] == null
          ? 0.0
          : (map['initialQtCl'] as num).toDouble(),
      finalQtCl:
          map['finalQtCl'] == null ? 0.0 : (map['finalQtCl'] as num).toDouble(),
      articles: map['articles'] == null
          ? []
          : List<ClosingStockBoutiqueArticle>.from(map['articles']
              ?.map((x) => ClosingStockBoutiqueArticle.fromMap(x))),
    );
  }

  @override
  Map<String, dynamic> toMap() {
    return {
      'closingDate': closingDate.toIso8601String(),
      'boutiqueId': boutiqueId,
      'id': id,
      'title': title,
      'initialQtCl': initialQtCl,
      'finalQtCl': finalQtCl,
      'articles': articles.map((x) => x.toMap()).toList(),
    };
  }

  static final closingStockBoutiqueArtCalibresDummy =
      ClosingStockBoutiqueCalibre(ClosingRange.dummyFeb.date,
          boutiqueId: 0,
          initialQtCl: 0,
          finalQtCl: 10,
          title: 'test',
          id: 1,
          articles: [
        ClosingStockBoutiqueArticle(
          ClosingRange.dummyFeb.date,
          calibreId: 1,
          id: 1,
          designation: 'test',
          unitsInOnePiece: 1,
          quantityIn: 10.0,
          quantityOut: 0.0,
          initialQtCl: 0.0,
          finalQtCl: 10.0,
        )
      ]);
}
