import 'package:models_weebi/src/closings/abstract/closing_boutique.dart';
import 'package:models_weebi/src/closings/closing_stock_article.dart';
import 'package:models_weebi/utils.dart';

class ClosingStockBoutiqueArticle extends ClosingStockArticle
    implements ClosingBoutiqueAbstract {
  @override
  int boutiqueId;

  ClosingStockBoutiqueArticle(
    super.closingDate, {
    this.boutiqueId = 0,
    required super.calibreId,
    required super.id,
    required super.designation,
    required super.unitsInOnePiece,
    required super.quantityIn,
    required super.quantityOut,
    required super.initialQtCl,
    required double finalQtCl,
  }) : super(finalQtCl: initialQtCl, price: 0.0, cost: 0.0);

  @override
  Map<String, dynamic> toMap() {
    return {
      'closingDate': closingDate.toIso8601String(),
      'boutiqueId': boutiqueId,
      'calibreId': calibreId,
      'id': id,
      'designation': designation,
      'unitsInOnePiece': unitsInOnePiece,
      'quantityIn': quantityIn,
      'quantityOut': quantityOut,
      'initialQtCl': initialQtCl,
      'finalQtCl': finalQtCl,
    };
  }

  factory ClosingStockBoutiqueArticle.fromMap(Map<String, dynamic> map) {
    return ClosingStockBoutiqueArticle(
      DateTime.tryParse(map['closingDate']) ?? DatesWeebi.defaultDate,
      boutiqueId: map['boutiqueId'] as int,
      calibreId: map['calibreId'] as int,
      id: map['id'] as int,
      designation: map['designation'] as String,
      unitsInOnePiece: map['unitsInOnePiece'] == null
          ? 1.0
          : (map['unitsInOnePiece'] as num).toDouble(),
      quantityIn: map['quantityIn'] == null
          ? 0.0
          : (map['quantityIn'] as num).toDouble(),
      quantityOut: map['quantityOut'] == null
          ? 0.0
          : (map['quantityOut'] as num).toDouble(),
      initialQtCl: map['initialQtCl'] == null
          ? 0.0
          : (map['initialQtCl'] as num).toDouble(),
      finalQtCl:
          map['finalQtCl'] == null ? 0.0 : (map['finalQtCl'] as num).toDouble(),
    );
  }
}
