import 'package:models_weebi/common.dart';
import 'package:models_weebi/src/models/article/photo_article.dart';
import 'package:models_weebi/src/models/article/article_retail.dart';
import 'package:models_weebi/src/models/article/calibre.dart';
import 'package:models_weebi/src/models/article/stock_unit.dart';
import 'package:models_weebi/utils.dart';

abstract class CalibresDemoJamsBM {
  static const jamsPhotos = [
    ArticlePhoto(
        calibreId: 1,
        id: 1,
        path: 'BM_Peches_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 2,
        id: 1,
        path: 'BM_Compotee_Abricot_600g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 3,
        id: 1,
        path: 'BM_Figues_violettes_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 4,
        id: 1,
        path: 'BM_Oranges_ameres_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 5,
        id: 1,
        path: 'BM_Abricots_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 6,
        id: 1,
        path: 'BM_Fraises_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 7,
        id: 1,
        path: 'BM_Framboises_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 8,
        id: 1,
        path: 'BM_Cerises_noires_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 9,
        id: 1,
        path: 'BM_Gelee_de_mures_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 10,
        id: 1,
        path: 'BM_Fruits_des_Bois_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 11,
        id: 1,
        path: 'BM_Cerises_griottes_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 12,
        id: 1,
        path: 'BM_Compotee_Peches_600g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 13,
        id: 1,
        path: 'BM_Quetsches_370g.jpg',
        source: PhotoSource.asset),
    ArticlePhoto(
        calibreId: 14,
        id: 1,
        path: 'BM_4_Fruits_370g.jpg',
        source: PhotoSource.asset),
  ];
  static final jamsData = [
    Calibre(
      id: 1,
      title: 'Confiture BM Peches',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 1,
          id: 1,
          designation: 'Confiture BM Peches 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 11,
          barcodeEAN: '3 04532000154 9',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 2,
      title: 'Confiture BM Compotee Abricot',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 2,
          id: 1,
          designation: 'Confiture BM Compotee Abricot 600g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 21,
          barcodeEAN: '3 04532000690 2',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 3,
      title: 'Confiture BM Figues violettes',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 3,
          id: 1,
          designation: 'Confiture BM Figues violettes 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 31,
          barcodeEAN: '3 04532000929 3',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 4,
      title: 'Confiture BM Oranges ameres',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 4,
          id: 1,
          designation: 'Confiture BM Oranges ameres 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 41,
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 5,
      title: 'Confiture BM Abricots',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 5,
          id: 1,
          designation: 'Confiture BM Abricots 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          barcodeEAN: '3 04532000153 2',
          articleCode: 51,
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 6,
      title: 'Confiture BM Fraises',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 6,
          id: 1,
          designation: 'Confiture BM Fraises 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 61,
          barcodeEAN: '3 04532000152 5',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 7,
      title: 'Confiture BM Framboises',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 7,
          id: 1,
          designation: 'Confiture BM Framboises 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          barcodeEAN: '3 04532000157 0',
          articleCode: 71,
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 8,
      title: 'Confiture BM Cerises noires',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 8,
          id: 1,
          designation: 'Confiture BM Cerises noires 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 81,
          barcodeEAN: '3 04532002327 5',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 9,
      title: 'Confiture BM Gelee de mures',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 9,
          id: 1,
          designation: 'Confiture BM Gelee de mures 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 91,
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 10,
      title: 'Confiture BM Fruits des Bois',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 10,
          id: 1,
          designation: 'Confiture BM Fruits des Bois 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 101,
          barcodeEAN: '3 04532000719 0',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 11,
      title: 'Confiture BM Cerises griottes',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 11,
          barcodeEAN: '3 04532000151 8',
          id: 1,
          designation: 'Confiture BM Cerises griottes 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 111,
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 12,
      title: 'Confiture BM Compotee Peches',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 12,
          id: 1,
          designation: 'Confiture BM Compotee Peches 600g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 121,
          barcodeEAN: '3 04532000691 9',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 13,
      title: 'Confiture BM Quetsches',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 13,
          id: 1,
          designation: 'Confiture BM Quetsches 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 131,
          barcodeEAN: '3 04532000160 0',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
    Calibre(
      id: 14,
      title: 'Confiture BM 4 Fruits',
      stockUnit: StockUnit.unit,
      status: true,
      creationDate: DatesWeebi.defaultDate,
      articles: [
        ArticleRetail(
          calibreId: 14,
          id: 1,
          designation: 'Confiture BM 4 Fruits 370g',
          unitsInOnePiece: 1.0,
          price: 100,
          cost: 50,
          articleCode: 141,
          barcodeEAN: '3 04532000165 5',
          creationDate: DatesWeebi.defaultDate,
        ),
      ],
    ),
  ];
}
