import 'package:models_weebi/closings.dart';
import 'package:models_weebi/abstracts.dart';

extension ArtCalibreClosingBoyFeelsGoodAfterGulpingTBoneSteak<
    T extends TicketRawAbstract> on T {
  void incrementMyClosingStockPlease(
      List<ClosingStockCalibre> stockArtCalibres) {
    for (final item in items) {
      final thisCoolStockArtCalibre = stockArtCalibres
          .firstWhere((element) => element.id == item.article.calibreId);
      for (final cArticle in thisCoolStockArtCalibre.articles) {
        if (cArticle.calibreId == item.article.calibreId &&
            cArticle.id == item.article.id) {
          if (ticketType.isBoutiqueInput) {
            cArticle.finalQtCl += item.quantity;
            cArticle.quantityIn += item.quantity;
            thisCoolStockArtCalibre.finalQtCl += item.quantity *
                cArticle.unitsInOnePiece; // allows us to reconcile stock
          } else {
            cArticle.finalQtCl -= item.quantity;
            cArticle.quantityOut += item.quantity;
            thisCoolStockArtCalibre.finalQtCl -=
                item.quantity * cArticle.unitsInOnePiece; // same
          }
        }
      }
    }
  }

  void incrementClosingStockBoutique(
      List<ClosingStockBoutiqueCalibre> stockBoutiqueArtCalibres) {
    for (final item in items) {
      final stockBoutiqueArtCalibre = stockBoutiqueArtCalibres
          .firstWhere((element) => element.id == item.article.calibreId);
      for (final cArticle in stockBoutiqueArtCalibre.articles) {
        if (cArticle.calibreId == item.article.calibreId &&
            cArticle.id == item.article.id) {
          if (ticketType.isBoutiqueInput) {
            cArticle.finalQtCl += item.quantity;
            cArticle.quantityIn += item.quantity;
            stockBoutiqueArtCalibre.finalQtCl += item.quantity *
                cArticle.unitsInOnePiece; // allows us to reconcile stock
          } else {
            cArticle.finalQtCl -= item.quantity;
            cArticle.quantityOut += item.quantity;
            stockBoutiqueArtCalibre.finalQtCl -=
                item.quantity * cArticle.unitsInOnePiece; // same
          }
        }
      }
    }
  }
}
