import 'package:models_weebi/src/closings/closing_ledger_contact.dart';
import 'package:models_weebi/src/extensions/closing_ledger_herders.dart';
import 'package:models_weebi/src/extensions/tickets_purchasing_power.dart';
import 'package:models_weebi/models.dart' show ContactWeebi, TicketWeebi;

class ContactBalance {
  final int id;
  final num balance;
  const ContactBalance(this.id, this.balance);

  static const listOfContactBalance = <ContactBalance>[
    ContactBalance(1, 10000),
    ContactBalance(2, 20000)
  ];
}

extension ContactsBalance on Iterable<ContactWeebi> {
  List<ContactBalance> makeListOfContactBalance(Iterable<TicketWeebi> tickets,
      Iterable<ClosingLedgerContact> closingsLedgerContacts,
      {DateTime? end}) {
    final listOfContactBalance = <ContactBalance>[];
    toList().sort((a, b) => a.id.compareTo(b.id));
    for (final herder in this) {
      final endNotNull = end ?? DateTime.now();

      final lastClosingBalance =
          closingsLedgerContacts.closingContactLastBalance(herder.id);

      final lent = 0;
      final ticketsPP =
          tickets.herderTicketsPurchasingPowerDateEnd(herder.id, endNotNull);

      final purchasingPower = ticketsPP + lastClosingBalance + lent;

      final bb = ContactBalance(herder.id, purchasingPower);
      listOfContactBalance.add(bb);
    }
    return listOfContactBalance;
  }
}
