import 'package:mobx/mobx.dart';
import 'package:models_weebi/abstracts.dart' show ContactAbstract;

extension ContactsSorted<C extends ContactAbstract> on ObservableList<C> {
  ObservableList<C> sortedByFirstName() {
    return ObservableList.of(
      this..sort((a, b) => a.firstName.compareTo(b.firstName)),
    );
  }

  ObservableList<C> sortedByLastName() {
    return ObservableList.of(
      this..sort((a, b) => a.lastName.compareTo(b.lastName)),
    );
  }

  ObservableList<C> sortedById() {
    return ObservableList.of(
      this..sort((a, b) => a.id.compareTo(b.id)),
    );
  }
}
