import 'package:mobx/mobx.dart';
import 'package:models_weebi/abstracts.dart';
import 'package:models_weebi/src/models/article/calibre.dart';

extension NextLineArticleId on ObservableList<Calibre> {
  int get nextId {
    if (isEmpty) {
      return 1;
    } else {
      final that = this
        ..sort((a, b) => a.id.compareTo(b.id))
        ..toList();
      if (that.last.id < 0) {
        return 1;
      } else {
        return that.last.id + 1;
      }
    }
  }
}

extension NextArticleId<A extends ArticleRawAbstract> on Iterable<A> {
  int get nextId {
    if (isEmpty) {
      return 1;
    } else {
      final that = toList()
        ..sort((a, b) => a.id.compareTo(b.id))
        ..toList();
      if (that.last.id < 0) {
        return 1;
      } else {
        return that.last.id + 1;
      }
    }
  }
}

extension NextContactId<C extends ContactAbstract> on Iterable<C> {
  int get nextId {
    if (isEmpty) {
      return 1;
    } else {
      final that = toList()
        ..sort((a, b) => a.id.compareTo(b.id))
        ..toList();
      if (that.last.id < 0) {
        return 1;
      } else {
        return that.last.id + 1;
      }
    }
  }
}

extension NextBoutiqueId<S extends BoutiqueAbstract> on Iterable<S> {
  int get nextId {
    if (isEmpty) {
      return 1;
    } else {
      final that = toList()
        ..sort((a, b) => a.id.compareTo(b.id))
        ..toList();
      if (that.last.id < 0) {
        return 1;
      } else {
        return that.last.id + 1;
      }
    }
  }
}

extension NextTicketId<T extends TicketRawAbstract> on ObservableSet<T> {
  int get nextId {
    if (isEmpty) {
      return 1;
    } else {
      final that = toList()
        ..sort((a, b) => a.id.compareTo(b.id))
        ..toList();
      if (that.last.id < 0) {
        return 1;
      } else {
        return that.last.id + 1;
      }
    }
  }
}
