// * WIP - might still need adjustments from yobi
import 'package:models_weebi/models.dart' show TicketType, TicketWeebi;
import 'package:models_weebi/src/closings/closing_stock_article_calibre.dart';
import 'package:models_weebi/src/closings/closing_stock_shop/closing_stock_boutique_art_calibre.dart';

extension ArtCalibreClosingBoyFeelsGoodAfterGulpingTBoneSteak on TicketWeebi {
  void incrementMyClosingStockContact(List<ClosingStockCalibre> stockCalibres) {
    // * handling milk business exception
    // le lait n'est pas 'sorti' dans yobi, pourtant en pratique vendu
    // et réinitialisé tous les mois donc on adapte le calcul et l'affichage du lait
    if (ticketType == TicketType.spendDeferred &&
        items.any((i) => i.article.calibreId != 6) == false) {
      for (final item in items) {
        var cStockArtCalibre =
            stockCalibres.firstWhere((cSP) => cSP.id == item.article.calibreId);
        for (var cArticle in cStockArtCalibre.articles) {
          if (cArticle.calibreId == item.article.calibreId &&
              cArticle.id == item.article.id) {
            cArticle.quantityIn += item.quantity;
            cArticle.quantityOut += item.quantity;
            cArticle.finalQtCl += item.quantity;
          }
        }
      }
    } else {
      // * standard
      for (final item in items) {
        final cStockArtCalibre = stockCalibres.firstWhere(
            (e) => e.id == item.article.calibreId,
            orElse: () =>
                throw 'error stockCalibres does not find productId match on : \nitem.article.productId${item.article.calibreId} ${item.article.calibreId.runtimeType}');
        for (final cArticle in cStockArtCalibre.articles) {
          if (cArticle.calibreId == item.article.calibreId &&
              cArticle.id == item.article.id) {
            // * if herder stock then opposite from shop stock
            // * herders might one day buy & sell same product
            if (ticketType.isContactInput) {
              // blw allows us to reconcile stock
              cArticle.quantityIn += item.quantity;
              cArticle.finalQtCl += item.quantity;
              // product
              cStockArtCalibre.finalQtCl +=
                  (item.quantity * cArticle.unitsInOnePiece);
            } else {
              cArticle.quantityOut += item.quantity;
              cArticle.finalQtCl -= item.quantity;
              // product
              cStockArtCalibre.finalQtCl -=
                  (item.quantity * cArticle.unitsInOnePiece); // same
            }
          }
        }
      }
    }
  }

  void incrementMyClosingStock(List<ClosingStockCalibre> stockCalibres) {
    // * handling milk business exception
    // le lait n'est pas 'sorti' dans yobi, pourtant en pratique vendu
    // et réinitialisé tous les mois donc on adapte le calcul et l'affichage du lait
    if (ticketType == TicketType.spendDeferred &&
        items.any((element) => element.article.calibreId != 6) == false) {
      for (final item in items) {
        final cStockArtCalibre = stockCalibres
            .firstWhere((element) => element.id == item.article.calibreId);
        for (final cArticle in cStockArtCalibre.articles) {
          if (cArticle.calibreId == item.article.calibreId &&
              cArticle.id == item.article.id) {
            cArticle.quantityIn += item.quantity;
            cArticle.quantityOut += item.quantity;
            cArticle.finalQtCl += item.quantity;
          }
        }
      }
    } else {
      // * standard
      for (final item in items) {
        final cStockArtCalibre = stockCalibres.firstWhere(
            (element) => element.id == item.article.calibreId, orElse: () {
          throw 'error stockCalibres does not find match productId on : \n${item.article.toJson()}';
        });
        for (final cArticle in cStockArtCalibre.articles) {
          if (cArticle.calibreId == item.article.calibreId &&
              cArticle.id == item.article.id) {
            // * if herder stock then opposite from shop stock
            // * herders might one day buy & sell same product
            if (ticketType.isBoutiqueInput) {
              cArticle.finalQtCl += item.quantity;
              cArticle.quantityIn += item.quantity;
              // product
              cStockArtCalibre.finalQtCl += (item.quantity *
                  cArticle.unitsInOnePiece); // allows us to reconcile stock
            } else {
              cArticle.finalQtCl -= item.quantity;
              cArticle.quantityOut += item.quantity;
              // product
              cStockArtCalibre.finalQtCl -=
                  (item.quantity * cArticle.unitsInOnePiece); // same
            }
          }
        }
      }
    }
  }

  void incrementClosingStockBoutique(
      List<ClosingStockBoutiqueCalibre> clStockBoutiqueArtCalibres) {
    // * handling milk business exception
    // le lait n'est pas 'sorti' dans yobi, pourtant en pratique vendu
    // et réinitialisé tous les mois donc on adapte le calcul et l'affichage du lait
    if (ticketType == TicketType.spendDeferred &&
        items.any((element) => element.article.calibreId != 6) == false) {
      for (final item in items) {
        final clStockBoutiqueArtCalibre = clStockBoutiqueArtCalibres.firstWhere(
            (element) => element.id == item.article.calibreId, orElse: () {
          throw 'error stockBoutiqueArtCalibres milk does not find match productId on : \n${item.article.toJson()}';
        });
        for (final cArticle in clStockBoutiqueArtCalibre.articles) {
          if (cArticle.calibreId == item.article.calibreId &&
              cArticle.id == item.article.id) {
            // distinction if (ticketType.isBoutiqueInput) pas pertinente on sait que c'est lait entrée
            // if (ticketType.isBoutiqueInput) {
            cArticle.quantityIn += item.quantity;
            cArticle.quantityOut += item.quantity;
            // } else {
            //   cArticle.finalQuantity -= item.quantity;
            //   cArticle.quantityOut += item.quantity;
            // }
          }
        }
      }
    } else {
      for (final item in items) {
        final stockBoutiqueArtCalibre = clStockBoutiqueArtCalibres
            .firstWhere((c) => c.id == item.article.calibreId, orElse: () {
          throw 'error stockBoutiqueArtCalibres does not find match productId on : \n${item.article.toJson()}';
        });
        for (final cArticle in stockBoutiqueArtCalibre.articles) {
          if (cArticle.calibreId == item.article.calibreId &&
              cArticle.id == item.article.id) {
            // distinction très importante, le produit peut être une entrée ou une sortie de stock du magasin
            if (ticketType.isBoutiqueInput) {
              cArticle.finalQtCl += item.quantity;
              cArticle.quantityIn += item.quantity;
              stockBoutiqueArtCalibre.finalQtCl += (item.quantity *
                  cArticle.unitsInOnePiece); // allows us to reconcile stock
            } else {
              cArticle.finalQtCl -= item.quantity;
              cArticle.quantityOut += item.quantity;
              stockBoutiqueArtCalibre.finalQtCl -=
                  (item.quantity * cArticle.unitsInOnePiece); // same
            }
          }
        }
      }
    }
  }
}
