// enum like
class ArticleKind {
  final String _kind;
  const ArticleKind._(this._kind);

  @override
  String toString() => _kind;

  static const ArticleKind retail = ArticleKind._('retail');
  static const ArticleKind basket = ArticleKind._('basket');
  static const ArticleKind outOfCatalogue = ArticleKind._('outOfCatalogue');
  static const ArticleKind unknown = ArticleKind._('unknown');

  static ArticleKind tryParse(String val) {
    switch (val) {
      case 'retail':
        return ArticleKind.retail;
      case 'basket':
        return ArticleKind.basket;
      case 'outOfCatalogue':
        return ArticleKind.outOfCatalogue;
      default:
        print('$val is not a valid ArticleKind');
        return ArticleKind.unknown;
    }
  }

  static String string(ArticleKind val) {
    if (val == ArticleKind.retail) {
      return 'retail';
    } else if (val == ArticleKind.basket) {
      return 'basket';
    } else if (val == ArticleKind.outOfCatalogue) {
      return 'outOfCatalogue';
    } else {
      return 'unknown';
    }
  }
}
