import 'dart:convert';

import 'package:models_weebi/src/models/article/abstract/article_kind.dart';
import 'package:models_weebi/src/models/article/abstract/article_raw_abstract.dart';
import 'package:models_weebi/src/models/article/basket_logic/proxy_article.dart';

abstract class ArticleBasketRawAbstract extends ArticleRawAbstract {
  final List<ProxyArticle> proxies;

  const ArticleBasketRawAbstract({
    required super.calibreId,
    required super.id,
    required super.designation,
    required this.proxies,
    super.status = true,
    super.kind = ArticleKind.basket,
  });

  @override
  Map<String, dynamic> toMap() {
    return {
      'calibreId': calibreId,
      'id': id,
      'kind': kind.toString(),
      'designation': designation,
      'proxies': proxies.map((x) => x.toMap()).toList(),
      'status': status,
    };
  }

  @override
  String toJson() => json.encode(toMap());

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is ArticleBasketRawAbstract &&
        other.calibreId == calibreId &&
        other.id == id &&
        other.kind == kind;
  }

  @override
  int get hashCode => proxies.hashCode ^ kind.hashCode;
}
