import 'dart:convert';

import 'package:models_weebi/src/models/article/abstract/article_kind.dart';
import 'package:models_weebi/src/models/article/abstract/article_raw_abstract.dart';
import 'package:models_weebi/src/models/article/price_and_cost.dart';

abstract class ArticleRetailRawAbstract extends ArticleRawAbstract
    implements Price, Cost {
  @override
  final num price;
  num get priceClean => num.parse(Price(price).toString());

  @override
  final num cost;
  num get costClean => num.parse(Cost(cost).toString());

  final double unitsInOnePiece;

  const ArticleRetailRawAbstract({
    required super.calibreId,
    required super.id,
    required super.designation,
    super.kind = ArticleKind.retail,
    super.status = true,
    required this.price,
    this.cost = 0,
    this.unitsInOnePiece = 1.0,
  });

  @override
  Map<String, dynamic> toMap() {
    return {
      'calibreId': calibreId,
      'id': id,
      'designation': designation,
      'kind': kind.toString(),
      'status': status,
      'price': price,
      'cost': cost,
      'unitsInOnePiece': unitsInOnePiece,
    };
  }

  @override
  String toJson() => json.encode(toMap());
}
