import 'package:models_weebi/src/models/article/abstract/article_raw_retail_abstract.dart';

/// Used only by articlebasket
/// to know how the minimum Qt (ex : 1 piece) of an article (retail) should go in the basket
///
class ArticleWMinQt extends ArticleRetailRawAbstract {
  double minQt = 1.0;
  ArticleWMinQt(
    this.minQt, {
    required super.calibreId,
    required super.id,
    required super.designation,
    required super.unitsInOnePiece,
    required super.price,
  });

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;
    return other is ArticleWMinQt &&
        other.designation == designation &&
        other.id == id &&
        other.calibreId == calibreId &&
        other.unitsInOnePiece == unitsInOnePiece;
  }

  static get dummy => ArticleWMinQt(1,
      calibreId: 1,
      id: 1,
      designation: 'dummy',
      unitsInOnePiece: 1.0,
      price: 0);

  @override
  int get hashCode => id.hashCode ^ designation.hashCode;
}
