import 'package:models_weebi/models.dart' show TicketType, TicketAbstract;

mixin TicketMixinWeebiBase on TicketAbstract {
  num calculateSumsOfTicket(
      TicketType ticketType, DateTime startOfMonth, DateTime endOfMonth) {
    if (ticketType == ticketType &&
        date.isAfter(startOfMonth) &&
        date.isBefore(endOfMonth)) {
      switch (ticketType) {
        case TicketType.sell:
          return totalPriceTaxAndPromoIncluded;
        case TicketType.sellDeferred:
          return totalPriceTaxAndPromoIncluded;
        case TicketType.sellCovered:
          return received;
        case TicketType.spend:
          return totalCostTaxAndPromoIncluded;
        case TicketType.spendDeferred:
          return totalCostTaxAndPromoIncluded;
        case TicketType.spendCovered:
          return received;
        case TicketType.wage:
          return received;
        case TicketType.unknown:
          print('unknow ticket type in calculateSumsOfTicket');
          return 0;
        default:
          return 0;
      }
    } else {
      return 0;
    }
  }

  double soldQtByArticle(
      String articleName, DateTime startOfMonth, DateTime endOfMonth) {
    double qty = 0;
    if (ticketType == TicketType.sell ||
        ticketType == TicketType.sellDeferred) {
      if (date.isAfter(startOfMonth) && date.isBefore(endOfMonth)) {
        for (var item in items) {
          if (item.article.designation == articleName) {
            qty += item.quantity;
          }
        }
      }
    }
    return qty;
  }

  num get sellFull {
    switch (ticketType) {
      case TicketType.sell:
        return totalPriceTaxAndPromoIncluded;
      // case TicketType.sellDeferred:
      //   return totalSellDeferredTtc;
      case TicketType.sellCovered:
        return received;
      default:
        return 0;
    }
  }

  num get spendFull {
    switch (ticketType) {
      case TicketType.spend:
        return totalCostTaxAndPromoIncluded;
      // case TicketType.spendDeferred:
      //   return totalSpendDeferredTtc;
      case TicketType.spendCovered:
        return received;
      case TicketType.unknown:
        print('unknow ticket type in calculateSumsOfTicket');
        return 0;
      default:
        return 0;
    }
  }
}
