library report_stocks;

import 'package:models_weebi/src/closings/closing_stock_contact.dart';
import 'package:models_weebi/src/closings/closing_stock_shop/closing_stock_boutique.dart';
import 'package:models_weebi/src/models/article/calibre.dart';
import 'package:models_weebi/src/models/boutique/boutique_weebi.dart';
import 'package:models_weebi/src/models/ticket/ticket_weebi.dart';
import 'package:models_weebi/src/reports/compute_stock_mixin.dart';
import 'package:models_weebi/src/reports/report_abstracts.dart';
import 'package:models_weebi/src/util/weebi_dates.dart';
import 'package:models_weebi/models.dart' show ContactWeebi;

class ReportStockContact extends ReportStockAbstract<ClosingStockContact>
    with ComputeStockContact {
  final ContactWeebi herder;
  ReportStockContact({
    required this.herder,
    required List<ClosingStockContact> closingContactStocks,
    required super.tickets,
    required super.articlesC,
    required super.startDate,
    required super.endDate,
  }) : super(
          objectId: herder.id,
          closingsObjects: closingContactStocks,
        );
}

class ReportStockBoutique extends ReportStockAbstract<ClosingStockBoutique>
    with ComputeStockBoutique {
  final BoutiqueWeebi shop;
  ReportStockBoutique({
    required this.shop,
    required List<ClosingStockBoutique> closingStockBoutiques,
    required super.tickets,
    required super.articlesC,
    required super.startDate,
    required super.endDate,
  }) : super(
          objectId: shop.id,
          closingsObjects: closingStockBoutiques,
        );
  // ignore: missing_required_param
  static final dummy = ReportStockBoutique(
      shop: BoutiqueWeebi.dummy,
      tickets: [TicketWeebi.dummySell],
      articlesC: [Calibre.dummyRetail],
      closingStockBoutiques: [],
      startDate: DatesWeebi.defaultFirstDate.add(const Duration(days: 1)),
      endDate: DatesWeebi.defaultLastDate.subtract(const Duration(days: 1)));
}
