import 'package:collection/collection.dart';
import 'package:models_weebi/utils.dart';

class DateRangesWithTimeSpan {
  final Timespan timespan;
  final List<DateRange> ranges;
  const DateRangesWithTimeSpan(this.timespan, this.ranges);

  DateRangesWithTimeSpan copyWith({
    Timespan? timespan,
    List<DateRange>? ranges,
  }) {
    return DateRangesWithTimeSpan(
      timespan ?? this.timespan,
      ranges ?? this.ranges,
    );
  }

  @override
  String toString() => 'TimeInterval(timespan: $timespan, ranges: $ranges)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;
    final listEquals = const DeepCollectionEquality().equals;

    return other is DateRangesWithTimeSpan &&
        other.timespan == timespan &&
        listEquals(other.ranges, ranges);
  }

  @override
  int get hashCode => timespan.hashCode ^ ranges.hashCode;
}
