import 'dart:convert';

import 'package:models_weebi/src/models/article/stock_unit.dart';
import 'package:models_weebi/src/models_dummies/article/calibre_dummy.dart';
import 'package:models_weebi/utils.dart';
import 'package:test/test.dart';

void main() {
  test('CalibreDummy serialisation', () {
    final articleJson = CalibreDummy().toJson();
    final Map<String, dynamic> map = json.decode(articleJson);

    final Map<String, dynamic> mapA = map['articles'][0];
    expect(mapA['id'], 1);
    expect(mapA['calibreId'], 1);
    expect(mapA['designation'], 'frometon forever');
    expect(mapA['status'], true);

    expect(StockUnit.unit, StockUnit.tryParse(map['stockUnit']));
    expect(map['categories'].first, 'categories');
    expect(map['id'], 1);
    expect(map['title'], 'frometon');
    expect(map['creationDate'], DatesWeebi.defaultDate.toIso8601String());
    expect(map['status'], true);
    expect(map['statusUpdateDate'], DatesWeebi.defaultDate.toIso8601String());
  });
}
