import 'dart:convert';

import 'package:models_weebi/src/models/common/address.dart';
import 'package:models_weebi/src/models/common/phone.dart';
import 'package:models_weebi/src/models_dummies/boutique_dummy.dart';
import 'package:models_weebi/utils.dart';
import 'package:test/test.dart';

void main() {
  test('boutique', () {
    print(Phone.empty.toMap());
    final shopJson = BoutiqueDummy().toJson();
    final Map<String, dynamic> map = (json.decode(shopJson));
    expect(map['id'] == BoutiqueDummy().id, isTrue);
    expect(
        map['managerMacAddress'] == BoutiqueDummy().managerMacAddress, isTrue);
    expect(map['name'] == 'name', isTrue);
    expect(map['mail'], BoutiqueDummy().mail);

    final phone = Phone.fromMap(map['phone']);
    expect(phone.countryCode, BoutiqueDummy().phone.countryCode);
    expect(phone.number, BoutiqueDummy().phone.number);

    final address = Address.fromMap(map['addressFull']);
    expect(address.city, BoutiqueDummy().addressFull.city);
    expect(address.code, BoutiqueDummy().addressFull.code);
    expect(address.country, BoutiqueDummy().addressFull.country);
    expect(address.latitude, BoutiqueDummy().addressFull.latitude);
    expect(address.longitude, BoutiqueDummy().addressFull.longitude);

    expect(map['shopKeeperName'], BoutiqueDummy().shopKeeperName);
    expect(map['shopKeeperTel'], BoutiqueDummy().shopKeeperTel);
    expect(map['shopKeeperMail'], BoutiqueDummy().shopKeeperMail);
    expect(
        map['updateDate'] == DatesWeebi.defaultDate.toIso8601String(), isTrue);
    expect(map['status'] == true, isTrue);
    expect(map['statusUpdateDate'] == DatesWeebi.defaultDate.toIso8601String(),
        isTrue);
    expect(map['serverStatus'] == true, isTrue);
    expect(
        map['serverStatusUpdateDate'] ==
            DatesWeebi.defaultDate.toIso8601String(),
        isTrue);
    expect(map['isProd'] == true, isTrue);
    expect(map['isLocked'] == false, isTrue);
    expect(map['promo'] == 0.0, isTrue);
  });
}
