import 'dart:convert';

import 'package:models_weebi/common.dart' show Address, Phone;
import 'package:models_weebi/models.dart' show ContactWeebi;
import 'package:test/test.dart';

void main() {
  test('contact', () {
    final contactJson = ContactWeebi.dummy.toJson();
    final Map<String, dynamic> map = json.decode(contactJson);

    expect(map['id'], ContactWeebi.dummy.id);
    expect(map['firstName'], ContactWeebi.dummy.firstName);
    expect(map['lastName'], ContactWeebi.dummy.lastName);
    expect(map['updateDate'], ContactWeebi.dummy.updateDate!.toIso8601String());
    expect(map['statusUpdateDate'],
        ContactWeebi.dummy.statusUpdateDate!.toIso8601String());
    expect(map['status'], ContactWeebi.dummy.status);

    expect(map['mail'], ContactWeebi.dummy.mail);

    final phone = Phone.fromMap(map['phone']);
    expect(phone.countryCode, ContactWeebi.dummy.phone.countryCode);
    expect(phone.number, ContactWeebi.dummy.phone.number);

    final address = Address.fromMap(map['addressFull']);
    expect(address.city, ContactWeebi.dummy.addressFull!.city);
    expect(address.code, ContactWeebi.dummy.addressFull!.code);
    expect(address.country, ContactWeebi.dummy.addressFull!.country);
    expect(address.latitude, ContactWeebi.dummy.addressFull!.latitude);
    expect(address.longitude, ContactWeebi.dummy.addressFull!.longitude);

    expect(map['avatar'], ContactWeebi.dummy.avatar);
    expect(map['isWomanTri'], ContactWeebi.dummy.isWomanTri.toString());
  });
}
