import 'package:models_weebi/common.dart' show Phone;
import 'package:models_weebi/models.dart' show Calibre, ContactWeebi;

import 'package:test/test.dart';
import 'package:models_weebi/extensions.dart';

void main() {
  group('find dups', () {
    test('in Calibre', () {
      final dummy = Calibre.dummyRetail;
      final oldList = [dummy];
      final newDummyPureDup = Calibre.dummyRetail;
      final newDummyDiff = Calibre.dummyRetail.copyWith(title: 'ptit avocat');
      final newList = [newDummyPureDup, newDummyDiff];

      final twoLists = oldList.findDupsByTitle(newList: newList);
      expect(twoLists.dups.length, 1);
      expect(twoLists.noDups.length, 1);
      expect(twoLists.noDups.first.title, 'ptit avocat');
    });
    test('single herder', () {
      final oldList = [ContactWeebi.defaultContact];
      final newList = [ContactWeebi.dummy];
      final twoLists = newList.findDupsByFields(newList: oldList);
      expect(twoLists.dups.length, 0);
      expect(twoLists.noDups.length, 1);
      expect(twoLists.noDups.first.firstName, 'John');
    });
    test('in herder', () {
      final dummy = ContactWeebi.dummy;
      final oldList = [dummy];

      final newDummyPureDup = ContactWeebi.dummy;
      final newDummyNameDup =
          ContactWeebi.dummy.copyWith(firstName: 'ptit couillon');
      final newDummyMailDup =
          ContactWeebi.dummy.copyWith(mail: 'ptitcouillon@gmail.com');

      final newDummyTelDiff = ContactWeebi.dummy.copyWith(
          firstName: 'ptit couillon bis',
          phone: Phone(0, '06'),
          mail: 'ptitcouillon@gmail.com');
      final newList = [
        newDummyPureDup,
        newDummyNameDup,
        newDummyMailDup,
        newDummyTelDiff,
      ];
      final twoLists = newList.findDupsByFields(newList: oldList);
      expect(twoLists.dups.length, 3);
      expect(twoLists.noDups.length, 1);
      expect(twoLists.noDups.first.phone.toString(), '06');
    });
  });
}
