// import 'package:models_weebi/src/models/article_weebi.dart';
import 'package:models_weebi/models.dart';
import 'package:test/test.dart';
import 'package:collection/collection.dart';

void main() {
  test('article basket with price and cost', () {
    final json = ArticleBasket.dummy.toJson();
    final dummy = ArticleBasket.fromJson(json);
    // ArticleBasket.dummy == x2 LineArticleRetail.dummy with price: 100, cost: 80,
    //Calibre.dummyBast has a price of 100);
    //Calibre.dummyBast has a cost of 80);
    final proxiesWorth = dummy.getProxiesListWithPriceAndCost(
        [Calibre.dummyRetail]); // mocking a list of articles in the store

    expect(dummy.id == ArticleBasket.dummy.id, isTrue);
    expect(dummy.calibreId == ArticleBasket.dummy.calibreId, isTrue);
    expect(dummy.designation == ArticleBasket.dummy.designation, isTrue);

    expect(proxiesWorth.basketTotalPrice(0, 0) == 100, isTrue);
    expect(proxiesWorth.baskeTotalCost(0, 0) == 80, isTrue);
    expect(dummy.articleCode == ArticleBasket.dummy.articleCode, isTrue);
    expect(dummy.creationDate == ArticleBasket.dummy.creationDate, isTrue);
    expect(dummy.status == ArticleBasket.dummy.status, isTrue);
    final listEquals = const DeepCollectionEquality().equals;
    expect(listEquals(dummy.proxies, ArticleBasket.dummy.proxies), isTrue);
  });
}
